searchNodes=[{"doc":"Used to interact with honeycomb.io's API for tracing and other data.InstallationAdding Honeylixir to your mix.exs as a dependency should suffice for installation:def deps() do [ {:honeylixir, &quot;~&gt; 0.3.0&quot;} ] endConfigurationYou can configure any of the following variables via Config:NameTypeDescriptionDefault:api_hoststringAPI to send events tohttps://api.honeycomb.io:sample_rateintegerRate at which events will be sampled represented as a percented. e.g., use 10 to send 10% of events1:team_writekeystringAPI key used to send eventsnil:datasetstring/atomDataset to send the events tonil:service_namestring/atomName of your service which will be added as a field on all events at the key &quot;service_name&quot;nil:max_queue_sizeintegerHow large the transmission queue can grow before events are dropped10_000:batch_sizeintegerHow many events to send per batch50:batch_timingintegerTime in milliseconds to try sending events from the queue in a batch100:max_send_processesintegerHow many Processes to use for sending events in the background30:max_response_queue_sizeintegerHow many responses for event sending can be held in the queue. Once reached, responses are dropped100It is required that you set :team_writekey and :dataset for events to be sent. Otherwise, they will return non-200 responses from Honeycomb resulting in the events being dropped. An example config may look like so (whether distillery or compile time Mix):config :honeylixir, dataset: :&quot;my-company&quot;, team_writekey: System.get_env(&quot;HONEYLIXIR_WRITEKEY&quot;), service_name: :my_applicationAdditionally, these are all defined on attributes so you can change them on a per event basis if desired.event = Honeylixir.Event.create() event = %{event | api_host: &quot;https://some-other-valid-host.com&quot;}UsageSending eventsHoneylixir provides the ability to make a Honeylixir.Event, add fields to it, then send it off asynchronously.Honeylixir.Event.create() |&gt; Honeylixir.Event.add_field(&quot;a_field&quot;, &quot;my_value&quot;) |&gt; Honeylixir.Event.add_field(&quot;something-else&quot;, %{&quot;nested&quot; =&gt; &quot;value&quot;}) |&gt; Honeylixir.Event.send()Any value can be used but fields are REQUIRED to be strings. Non-string fields will result in a no matching function clause error.Checking responsesBy attaching metadata to your events, you can pull Honeylixir.Responses to see what happened to your event. This data is stored in the Honeylixir.ResponseQueue which acts as a small data store.Honeylixir.Event.create() |&gt; Honeylixir.Event.send() # wait for event to async send off resp = Honeylixir.ResponseQueue.pop()","ref":"Honeylixir.html","title":"Honeylixir","type":"module"},{"doc":"Generates a random string of 16 bytes encoded in base 16.","ref":"Honeylixir.html#generate_long_id/0","title":"Honeylixir.generate_long_id/0","type":"function"},{"doc":"Generates a random string of 8 bytes encoded in base 16.","ref":"Honeylixir.html#generate_short_id/0","title":"Honeylixir.generate_short_id/0","type":"function"},{"doc":"Used for managing Events and holding their data. It also has a send function that really just kicks off the sending process which happens asynchronously.","ref":"Honeylixir.Event.html","title":"Honeylixir.Event","type":"module"},{"doc":"Adds a map of fields into the existing set.Examplesiex&gt; event = Honeylixir.Event.create() iex&gt; Honeylixir.Event.add(event, %{&quot;another&quot; =&gt; &quot;field&quot;, &quot;service_name&quot; =&gt; &quot;foobar&quot;}).fields %{&quot;service_name&quot; =&gt; &quot;foobar&quot;, &quot;another&quot; =&gt; &quot;field&quot;}","ref":"Honeylixir.Event.html#add/2","title":"Honeylixir.Event.add/2","type":"function"},{"doc":"Add a single key/value pair to the event.Examplesiex&gt; event = Honeylixir.Event.create() iex&gt; Honeylixir.Event.add_field(event, &quot;key&quot;, &quot;other&quot;).fields %{&quot;service_name&quot; =&gt; &quot;honeylixir-tests&quot;, &quot;key&quot; =&gt; &quot;other&quot;}","ref":"Honeylixir.Event.html#add_field/3","title":"Honeylixir.Event.add_field/3","type":"function"},{"doc":"Adds to the metadata of the event.This information is NOT passed along to LaunchDarkly and should only be used by the consuming application to keep track of an event.Examplesiex&gt; event = Honeylixir.Event.create() iex&gt; Honeylixir.Event.add_metadata(event, %{&quot;some_key&quot; =&gt; &quot;some_value&quot;}).metadata %{&quot;some_key&quot; =&gt; &quot;some_value&quot;}","ref":"Honeylixir.Event.html#add_metadata/2","title":"Honeylixir.Event.add_metadata/2","type":"function"},{"doc":"Creates an event using the current timestamp, configured values for sending, and no initial fields other than service_name if configured.event = Honeycomb.Event.create()","ref":"Honeylixir.Event.html#create/0","title":"Honeylixir.Event.create/0","type":"function"},{"doc":"create/1 accepts either a timestamp or a set of fields to initialize the Honeylixir.Event.event = Honeylixir.Event.create(&quot;2020-09-29 04:36:15Z&quot;) event = Honeylixir.Event.create(%{&quot;field1&quot; =&gt; &quot;value1&quot;})","ref":"Honeylixir.Event.html#create/1","title":"Honeylixir.Event.create/1","type":"function"},{"doc":"Accepts both a timestamp in RFC3339 format and a map of key/values to initialize the Event struct with.","ref":"Honeylixir.Event.html#create/2","title":"Honeylixir.Event.create/2","type":"function"},{"doc":"Used for acknowledging the event is ready for sending, passing it off to be sent asynchronously. Currently nothing stops a user from sending the same event twice.If the event is sampled, a Honeylixir.Response is added to the Honeylixir.ResponseQueue with the err attribute set to :sampled.","ref":"Honeylixir.Event.html#send/1","title":"Honeylixir.Event.send/1","type":"function"},{"doc":"An RFC3339 formatted timestamp&quot;2020-09-29 04:36:15Z&quot;","ref":"Honeylixir.Event.html#t:rfc_timestamp/0","title":"Honeylixir.Event.rfc_timestamp/0","type":"type"},{"doc":"A struct containing all the data of an event.By default, an event is constructed with the values in the configuration defined in Honeylixir. Any field can be overwritten via regular struct assigning of values.event = Honeylixir.Event.create() event = %{event | api_host: &quot;something-else.com&quot;}An Event also includes two other fields:fields - The set of fields which will be sent to Honeycomb as the event bodymetadata - A map of extra data that may be provided as part of a response.","ref":"Honeylixir.Event.html#t:t/0","title":"Honeylixir.Event.t/0","type":"type"},{"doc":"","ref":"Honeylixir.Response.html","title":"Honeylixir.Response","type":"module"},{"doc":"Response object with data about an event after a send attempt.metadata - the metadata from the Event a user can use to correlate this response with a specific eventduration - time in ms it took to send the event, HTTP time only.status_code - status code for this event from Honeycombbody - the body associated with this eventerr - set if an error occurs in sending, such as a max queue size overflow or when the event is sampled","ref":"Honeylixir.Response.html#t:t/0","title":"Honeylixir.Response.t/0","type":"type"},{"doc":"Available for tracking responses for each event sent via Honeylixir.Transmission.Currently does not block when the queue is full.","ref":"Honeylixir.ResponseQueue.html","title":"Honeylixir.ResponseQueue","type":"module"},{"doc":"Adds a Honeylixir.Response to the queue unless max size has been reached at which point the value is dropped.","ref":"Honeylixir.ResponseQueue.html#add/2","title":"Honeylixir.ResponseQueue.add/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Honeylixir.ResponseQueue.html#child_spec/1","title":"Honeylixir.ResponseQueue.child_spec/1","type":"function"},{"doc":"Takes the oldest Honeylixir.Response from the queue and returns it unless the queue is empty in which case nil is returned.","ref":"Honeylixir.ResponseQueue.html#pop/1","title":"Honeylixir.ResponseQueue.pop/1","type":"function"},{"doc":"Transmission engine that handles sending events to the expected place.Events have a complicated lifetime from being sent here, possibly sampled out, enqueued, then finally asynchronously sent in a batch. This handles figuring out where it needs to go, sort of like a router and initialy processor for sending events.","ref":"Honeylixir.Transmission.html","title":"Honeylixir.Transmission","type":"module"},{"doc":"Handles sending the batch to a transmission sender task to be processed asynchronously.","ref":"Honeylixir.Transmission.html#send_batch/1","title":"Honeylixir.Transmission.send_batch/1","type":"function"},{"doc":"Queue for processing and managing events to be sent.","ref":"Honeylixir.TransmissionQueue.html","title":"Honeylixir.TransmissionQueue","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Honeylixir.TransmissionQueue.html#child_spec/1","title":"Honeylixir.TransmissionQueue.child_spec/1","type":"function"},{"doc":"Accepts an event and asynchronously adds it to the queue for processing.","ref":"Honeylixir.TransmissionQueue.html#enqueue_event/1","title":"Honeylixir.TransmissionQueue.enqueue_event/1","type":"function"},{"doc":"Synchronously pulls all known queue keys from the state","ref":"Honeylixir.TransmissionQueue.html#get_all_queue_keys/0","title":"Honeylixir.TransmissionQueue.get_all_queue_keys/0","type":"function"},{"doc":"Asynchronously instructs the GenServer to prepare a batch for the given key to be sent.","ref":"Honeylixir.TransmissionQueue.html#process_batch/1","title":"Honeylixir.TransmissionQueue.process_batch/1","type":"function"},{"doc":"","ref":"Honeylixir.TransmissionQueue.html#t:t_queue_key/0","title":"Honeylixir.TransmissionQueue.t_queue_key/0","type":"type"},{"doc":"Typically invoked as a Task, handles sending the Honeylixir.Event batches to the Honeylixir.Client and adding responses to the queue.","ref":"Honeylixir.TransmissionSender.html","title":"Honeylixir.TransmissionSender","type":"module"},{"doc":"Does the actual passoff to the Honeylixir.Client for sending.Responses are added to the Honeylixir.ResponseQueue as they complete.","ref":"Honeylixir.TransmissionSender.html#send_batch/1","title":"Honeylixir.TransmissionSender.send_batch/1","type":"function"}]